Base Language - Feature #1972

provide full-support for DYNAMIC-FUNCTION set to function parameters
01/23/2013 10:35 AM - Constantin Asofiei

Status: Closed Start date: 08/06/2013
Assignee: Constantin Asofiei % Done: 100%
Category: Estimated time: 1.00 hour
Target version: Runtime Support for Server Features

billable: No vendor _id: GCD
Description

Related issues:
Related to Base Language - Feature #1920: implement persistent procedures Closed

History

#1 - 01/23/2013 10:42 AM - Constantin Asofiei

In 4GL, when a parameter of a function call is set as the the returned value of a DYNAMIC-FUNCTION call, as in:

function fi returns int (i as int):
return 1i.

end.

function fch returns char(ch as char):
return ch.

end.
message fi(dynamic-function("fch", "0")). /* this shows number 0*/
message fi(dynamic-function("fch", "a")). /* this shows number parsing error and the ? char */

4GL performs an "auto-cast" from the real value's type to the expected parameter's type. The full rules are not fully-discovered yet, but at least for the
above case, a string containing a valid number will be converted to its numeric representation.
The same applies for assignments, as in:

def var i as int.
i = fi(dynamic-function("fch", "0")). /* i gets set to 0*/

i = fi(dynamic—-function("fch", "a")). /* this shows number parsing error and i gets set to unknown*/

This suggests that the implementation of this kind of parsing needs to be done at the assign method for each P2J implementation of the 4GL types.
These assign methods in turn would get invoked from the i.e. new integer(BaseDataType) c'tor too, to allow proper parsing.
#2 - 04/12/2013 04:33 AM - Constantin Asofiei

- Estimated time set to 1.00

This is a _POLY case which should be solved by #2068 changes for _POLY cases. Estimate 1h to confirm.

#3 - 04/26/2013 09:57 AM - Greg Shah
- Assignee set to Constantin Asofiei

- Start date set to 08/15/2013

- Target version set to Milestone 7

- Due date set to 08/15/2013

#4 - 05/01/2013 02:29 PM - Greg Shah
- Start date changed from 08/15/2013 to 08/30/2013
- Due date changed from 08/15/2013 to 08/30/2013

#5 - 05/02/2013 12:25 PM - Greg Shah
- Due date changed from 08/30/2013 to 08/06/2013

- Start date changed from 08/30/2013 to 08/06/2013

#6 - 11/16/2013 04:44 AM - Constantin Asofiei

- Status changed from New to Feedback
This is fixed by #2068. Can be closed.
#7 - 11/18/2013 11:21 AM - Greg Shah
- % Done changed from 0 to 100

- Status changed from Feedback to Closed

#8 - 11/16/2016 11:43 AM - Greg Shah

- Target version changed from Milestone 7 to Runtime Support for Server Features
